// TraderSpi.cpp: implementation of the CTraderSpi class.
//
//////////////////////////////////////////////////////////////////////

//#include "StdAfx.h"
#include "TraderSpi.h"
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include "PublicDefine.h"
#include "stdarg.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CTraderSpi::CTraderSpi()
{
	m_pUserApi = NULL;
	m_nRequestId = 0;
	m_bOpen = true;
	m_bLogedIn = false;
}

CTraderSpi::~CTraderSpi()
{
	if (m_pUserApi)
	{
		m_pUserApi->Release();
		m_pUserApi = NULL;
	}
}

void CTraderSpi::OnFrontConnected()
{
	///û¼
	ReqUserLogin();
}

void CTraderSpi::ReqUserLogin()
{
	CThostFtdcReqUserLoginField req;
	memset(&req, 0, sizeof(req));
	strcpy(req.BrokerID, "3030");
	strcpy(req.UserID, m_userName);
	strcpy(req.Password, m_password);
	int iResult = m_pUserApi->ReqUserLogin(&req, ++m_nRequestId);
	if (iResult == 0)
	{
		FormatLog(LOG_APP_LEVEL, "ReqUserLogin", "½ɹ");
	}
	else
	{
		FormatLog(LOG_ERROR_LEVEL, "ReqUserLogin", "ʧ");
	}
}

void CTraderSpi::OnRspUserLogin( CThostFtdcRspUserLoginField *pRspUserLogin, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (bIsLast && !IsErrorRspInfo(pRspInfo))
	{
		m_frontID = pRspUserLogin->FrontID;
		m_sessionID = pRspUserLogin->SessionID;
		int iNextOrderRef = atoi(pRspUserLogin->MaxOrderRef);
		iNextOrderRef++;
		sprintf(m_orderRef, "%d", iNextOrderRef);
		FormatLog(LOG_APP_LEVEL, "OnRspUserLogin", "User [%s] Login success", pRspUserLogin->UserID);
		m_bLogedIn = true;
	}
	else
	{
		char strFormat[500];
		sprintf(strFormat, "User [%s] Login Failure ErrCode:%d, ErrMsg:%s", pRspUserLogin->UserID, pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_APP_LEVEL, "OnRspUserLogin", strFormat);
	}
}

void CTraderSpi::OnRspSettlementInfoConfirm( CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnRspQryInstrument( CThostFtdcInstrumentField *pInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnRspQryTradingAccount( CThostFtdcTradingAccountField *pTradingAccount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnRspQryInvestorPosition( CThostFtdcInvestorPositionField *pInvestorPosition, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::ReqOrderInsert(char* chInstrment, double price, char offsetFlag, char direction, int volumn)
{
	CThostFtdcInputOrderField req;
	memset(&req, 0, sizeof(req));
	///͹˾
	strcpy(req.BrokerID, "3030");
	///Ͷߴ
	strcpy(req.InvestorID, m_userName);
	///Լ
	strcpy(req.InstrumentID, chInstrment);
	///
	strcpy(req.OrderRef, m_orderRef);
	///û
	//	TThostFtdcUserIDType	UserID;
	///۸: ޼
	//req.OrderPriceType = THOST_FTDC_OPT_LimitPrice;
	req.OrderPriceType = THOST_FTDC_OPT_AnyPrice;
	///: 
	req.Direction = direction;
	///Ͽƽ־: 
	req.CombOffsetFlag[0] = offsetFlag;
	///Ͷױ־
	req.CombHedgeFlag[0] = THOST_FTDC_HF_Speculation;
	///۸
	req.LimitPrice = price;
	///: 1
	req.VolumeTotalOriginal = volumn;

	//	TThostFtdcDateType	GTDDate;
	///ɽ: κ
	req.VolumeCondition = THOST_FTDC_VC_AV;
	///Сɽ: 1
	req.MinVolume = 1;
	///: 
	req.ContingentCondition = THOST_FTDC_CC_Immediately;
	///ֹ
	//	TThostFtdcPriceType	StopPrice;
	///ǿƽԭ: ǿƽ
	req.ForceCloseReason = THOST_FTDC_FCC_NotForceClose;
	///Զ־: 
	req.IsAutoSuspend = 0;
	///ҵԪ
	//	TThostFtdcBusinessUnitType	BusinessUnit;
	///
	//	TThostFtdcRequestIDType	RequestID;
	///ûǿ־: 
	req.UserForceClose = 0;
	
	int iResult = m_pUserApi->ReqOrderInsert(&req, ++m_nRequestId);
	FormatLog(LOG_APP_LEVEL, "OrderInsert", "User:[%s] insert [%s][%s] [Price:%.2lf][Amount:%d]",
		m_userName, chInstrment, direction=='0'? "":"", price, volumn);
}

///󱨵¼(ûµ)
void CTraderSpi::OnRspOrderInsert( CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (IsErrorRspInfo(pRspInfo))
	{
		char strTmp[500];
		sprintf(strTmp, "Error response errCode:%d, errMsg:%s", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_ERROR_LEVEL, "OnRspOrderInsert", strTmp);
	}
	else
	{
		FormatLog(LOG_APP_LEVEL, "OnRspOrderInsert", "Sucess");	
	}
}

void CTraderSpi::ReqOrderAction( CThostFtdcInputOrderActionField *pOrder )
{
	int iResult = m_pUserApi->ReqOrderAction(pOrder, ++m_nRequestId);
}

void CTraderSpi::OnRspOrderAction( CThostFtdcInputOrderActionField *pInputOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (pRspInfo && pRspInfo->ErrorID != 0)
	{
		char strFormat[500];
		sprintf(strFormat, "ʧ:[%d-%s]", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_ERROR_LEVEL, "OnRspOrderAction", strFormat);
	}
	else
	{
		FormatLog(LOG_APP_LEVEL, "OnRspOrderAction", "Rsp success");
	}
}

void CTraderSpi::OnRspError( CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	
}

void CTraderSpi::OnFrontDisconnected( int nReason )
{
	char strTmp[500];
	sprintf(strTmp, "Reason: %d", nReason);
	FormatLog(LOG_APP_LEVEL, "OnFrontDisconnected", strTmp);
}

void CTraderSpi::OnHeartBeatWarning( int nTimeLapse )
{
	
}

void CTraderSpi::OnRtnOrder( CThostFtdcOrderField *pOrder )
{
	FormatLog(LOG_APP_LEVEL, "OnRtnOrder", "Rtn order");
}

void CTraderSpi::OnRtnTrade( CThostFtdcTradeField *pTrade )
{
	FormatLog(LOG_APP_LEVEL, "OnRtnTrade", "Rtn trade");
}

void CTraderSpi::ReqSettlementInfoConfirm()
{
	
}

void CTraderSpi::ReqQryInstrument()
{
	
}

void CTraderSpi::ReqQryTradingAccount()
{
	
}

void CTraderSpi::ReqQryInvestorPosition()
{
	
}

bool CTraderSpi::IsErrorRspInfo( CThostFtdcRspInfoField *pRspInfo )
{
	return ((pRspInfo) && (pRspInfo->ErrorID != 0));
}

bool CTraderSpi::IsMyOrder( CThostFtdcOrderField *pOrder )
{
	return ((pOrder->FrontID == m_frontID) &&
		(pOrder->SessionID == m_sessionID) &&
			(strcmp(pOrder->OrderRef, m_orderRef) == 0));
}

bool CTraderSpi::IsTradingOrder( CThostFtdcOrderField *pOrder )
{
	return ((pOrder->OrderStatus != THOST_FTDC_OST_PartTradedNotQueueing) &&
		(pOrder->OrderStatus != THOST_FTDC_OST_Canceled) &&
			(pOrder->OrderStatus != THOST_FTDC_OST_AllTraded));
}

void CTraderSpi::FormatLog( int nLevel, const char* strDomain, const char* szFormat, ...)
{
	char strLog[500],szParam[500];
	switch(nLevel)
	{
	case LOG_APP_LEVEL:
		sprintf(strLog, "CTraderSpi::%s\t [Info] ", strDomain);
		break;
	case LOG_DEBUG_LEVEL:
		sprintf(strLog, "CTraderSpi::%s\t [Debug] ", strDomain);
		break;
	case LOG_WARN_LEVEL:
		sprintf(strLog, "CTraderSpi::%s\t [Warn] ", strDomain);
		break;
	case LOG_ERROR_LEVEL:
		sprintf(strLog, "CTraderSpi::%s\t [Err] ", strDomain);
		break;
	}
	va_list args;
	va_start(args,szFormat);
	vsnprintf(szParam, 490, szFormat, args);
	va_end(args);
	strcat(strLog, szParam);
	cout<<strLog<<endl;

}

void CTraderSpi::Init(char* szAddress )
{
	if (m_pUserApi == NULL)
	{
		m_pUserApi = CThostFtdcTraderApi::CreateFtdcTraderApi();
		m_pUserApi->RegisterSpi(this);
		m_pUserApi->RegisterFront(szAddress);
		m_pUserApi->Init();
	}
}

void CTraderSpi::ReqQryInvestorPositionDetail(CThostFtdcQryInvestorPositionDetailField *pQryInvestorPositionDetail)
{
	m_pUserApi->ReqQryInvestorPositionDetail(pQryInvestorPositionDetail, ++m_nRequestId);
}

void CTraderSpi::OnRspQryInvestorPositionDetail( CThostFtdcInvestorPositionDetailField *pInvestorPositionDetail, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (pRspInfo && pRspInfo->ErrorID != 0)
	{
		FormatLog(LOG_ERROR_LEVEL, "OnRspQryInvestorPositionDetail", pRspInfo->ErrorMsg);
	}
	else
	{
		char szFormat[500];
		sprintf(szFormat,"Date:%s, Flag:%s, Ins:%s, volume:%d, price:%.2lf", pInvestorPositionDetail->TradingDay, 
			pInvestorPositionDetail->Direction == THOST_FTDC_D_Buy ? "":"ղ", pInvestorPositionDetail->InstrumentID, 
			pInvestorPositionDetail->Volume, pInvestorPositionDetail->OpenPrice);
		FormatLog(LOG_APP_LEVEL, "OnRspQryInvestorPositionDetail", szFormat);
	}
	if (bIsLast)
	{
		FormatLog(LOG_APP_LEVEL, "OnRspQryInvestorPositionDetail", "Query done");
	}
}

void CTraderSpi::ReqQryOrder( CThostFtdcQryOrderField *pQryOrder )
{
	int iResult = m_pUserApi->ReqQryOrder(pQryOrder, ++m_nRequestId);
	if (iResult != 0)
	{
		FormatLog(LOG_APP_LEVEL, "ReqQryOrder", "ѯʧ");
	}
}

void CTraderSpi::OnRspQryOrder( CThostFtdcOrderField *pOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast )
{
	if (pRspInfo && pRspInfo != 0)
	{
		char szBuf[500];
		sprintf(szBuf, "ErrorID:%d, ErrMsg:%s", pRspInfo->ErrorID, pRspInfo->ErrorMsg);
		FormatLog(LOG_APP_LEVEL, "RspOrder", szBuf);
	}
	else
	{
		if (pOrder->OrderStatus == '1' || pOrder->OrderStatus == '3' || pOrder->OrderStatus == 'b')
		{
		//	m_pDlg->AddNewUntradeOrder(pNewOrder, false);
		}
		if (bIsLast)
		{
			//m_pDlg->AddNewUntradeOrder(NULL, true);
		}
	}
}

void CTraderSpi::SetUserInfo( const char* chUserName, const char* chPsw )
{
	strcpy(m_userName, chUserName);
	strcpy(m_password, chPsw);
}
