// TraderSpi.h: interface for the CTraderSpi class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRADERSPI_H__43862588_D1C0_4AB9_9356_68D1900AB786__INCLUDED_)
#define AFX_TRADERSPI_H__43862588_D1C0_4AB9_9356_68D1900AB786__INCLUDED_

#include "ThostFtdcTraderApi.h"
#include <stdio.h>

class CTraderSpi : public CThostFtdcTraderSpi
{
public:
	CTraderSpi();
	~CTraderSpi();
	void Init(char* szAddress);
	bool GetLoginStatus() { return 	m_bLogedIn;}
public:
	///ͻ뽻׺̨ͨʱδ¼ǰ÷á
	virtual void OnFrontConnected();
	
	///¼Ӧ
	virtual void OnRspUserLogin(CThostFtdcRspUserLoginField *pRspUserLogin,	CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///Ͷ߽ȷӦ
	virtual void OnRspSettlementInfoConfirm(CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ѯԼӦ
	virtual void OnRspQryInstrument(CThostFtdcInstrumentField *pInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ѯʽ˻Ӧ
	virtual void OnRspQryTradingAccount(CThostFtdcTradingAccountField *pTradingAccount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ѯͶֲ߳Ӧ
	virtual void OnRspQryInvestorPosition(CThostFtdcInvestorPositionField *pInvestorPosition, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///¼Ӧ
	virtual void OnRspOrderInsert(CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///Ӧ
	virtual void OnRspOrderAction(CThostFtdcInputOrderActionField *pInputOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///Ӧ
	virtual void OnRspError(CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	
	///ͻ뽻׺̨ͨӶϿʱ÷áAPIԶӣͻ˿ɲ
	virtual void OnFrontDisconnected(int nReason);
	
	///ʱ档ʱδյʱ÷á
	virtual void OnHeartBeatWarning(int nTimeLapse);
	
	///֪ͨ
	virtual void OnRtnOrder(CThostFtdcOrderField *pOrder);
	
	///ɽ֪ͨ
	virtual void OnRtnTrade(CThostFtdcTradeField *pTrade);

	///ѯͶֲ߳ϸӦ
	virtual void OnRspQryInvestorPositionDetail(CThostFtdcInvestorPositionDetailField *pInvestorPositionDetail, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);

	///ѯر
	virtual void OnRspQryOrder(CThostFtdcOrderField *pOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
public:
	///û
	void SetUserInfo(const char* chUserName, const char* chPsw);
	///û¼
	void ReqUserLogin();
	///Ͷ߽ȷ
	void ReqSettlementInfoConfirm();
	///ѯԼ
	void ReqQryInstrument();
	///ѯʽ˻
	void ReqQryTradingAccount();
	///ѯͶֲ߳
	void ReqQryInvestorPosition();
	///ѯͶֲ߳ϸ
	void ReqQryInvestorPositionDetail(CThostFtdcQryInvestorPositionDetailField *pQryInvestorPositionDetail);
	///¼
	void ReqOrderInsert(char* chInstrment, double price, char offsetFlag, char direction, int volumn);
	///
	void ReqOrderAction(CThostFtdcInputOrderActionField *pOrder);
	///󱨵
	void ReqQryOrder(CThostFtdcQryOrderField *pQryOrder);
private:
	// ǷյɹӦ
	bool IsErrorRspInfo(CThostFtdcRspInfoField *pRspInfo);
	// Ƿҵıر
	bool IsMyOrder(CThostFtdcOrderField *pOrder);
	// Ƿڽ׵ı
	bool IsTradingOrder(CThostFtdcOrderField *pOrder);

	///־
	void FormatLog(int nLevel, const char* strDomain, const char* strText, ...);
private:
	///ͨŵAPI
	CThostFtdcTraderApi*		m_pUserApi;
	///ǰñ
	TThostFtdcFrontIDType		m_frontID;
	///Ự
	TThostFtdcSessionIDType		m_sessionID;
	///
	TThostFtdcOrderRefType		m_orderRef;
	///û
	TThostFtdcUserNameType		m_userName;
	///
	TThostFtdcPasswordType		m_password;
	///ԺԼ
	TThostFtdcInstrumentIDType	m_instrument;
	///
	int							m_nRequestId;
	///ּ
	double						m_dOpenPrice;
	///ƽּ
	double						m_dClosePrice;
	///ƽѡ
	bool						m_bOpen;
	///Ƿ½ɹ
	bool						m_bLogedIn;
};

#endif // !defined(AFX_TRADERSPI_H__43862588_D1C0_4AB9_9356_68D1900AB786__INCLUDED_)
